## ros-galactic-cv-bridge 3.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(cv_bridge)

find_package(ament_cmake_ros REQUIRED)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

if(NOT ANDROID)
  find_package(PythonLibs REQUIRED)
  if(PYTHONLIBS_VERSION_STRING VERSION_LESS 3)
    find_package(Boost REQUIRED python)
  else()
    find_package(Boost QUIET)
    message(STATUS "Boost_VERSION_STRING: " ${Boost_VERSION_STRING})
    if(Boost_VERSION_STRING VERSION_LESS "1.67")
      # This is a bit of a hack to suppress a warning
      #   No header defined for python3; skipping header check
      # Which should only affect Boost versions < 1.67
      # Resolution for newer versions:
      #  https://gitlab.kitware.com/cmake/cmake/issues/16391
      set(_Boost_PYTHON3_HEADERS "boost/python.hpp")
      find_package(Boost REQUIRED python3)
    else()
      string(REPLACE "." ";" VERSION_LIST ${PYTHONLIBS_VERSION_STRING})
      list(GET VERSION_LIST 0 PYTHONLIBS_VERSION_MAJOR)
      list(GET VERSION_LIST 1 PYTHONLIBS_VERSION_MINOR)
      find_package(Boost COMPONENTS python${PYTHONLIBS_VERSION_MAJOR}${PYTHONLIBS_VERSION_MINOR} REQUIRED)
    endif()
  endif()
else()
  find_package(Boost REQUIRED)
endif()

find_package(rcpputils REQUIRED)
find_package(sensor_msgs REQUIRED)

find_package(OpenCV 4 QUIET
  COMPONENTS
    opencv_core
    opencv_imgproc
    opencv_imgcodecs
  CONFIG
)
if(NOT OpenCV_FOUND)
  find_package(OpenCV 3 REQUIRED
    COMPONENTS
      opencv_core
      opencv_imgproc
      opencv_imgcodecs
    CONFIG
  )
endif()

if(NOT ANDROID)
  ament_python_install_package(${PROJECT_NAME}
    PACKAGE_DIR python/${PROJECT_NAME}
  )
endif()

add_subdirectory(src)

# cv_bridge_lib_dir is passed as APPEND_LIBRARY_DIRS for each ament_add_gtest call so
# the project library that they link against is on the library path.
# This is especially important on Windows.
# This is overwritten each loop, but which one it points to doesn't really matter.
set(cv_bridge_lib_dir "$<TARGET_FILE_DIR:${PROJECT_NAME}>")

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

ament_export_dependencies(
  OpenCV
  sensor_msgs
)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

# install the include folder
install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
)

install(TARGETS ${PROJECT_NAME}
        RUNTIME DESTINATION bin
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib
)

ament_package(
  CONFIG_EXTRAS "cmake/cv_bridge-extras.cmake.in"
)

=== src/CMakeLists.txt ===
# add library
add_library(${PROJECT_NAME} cv_bridge.cpp rgb_colors.cpp)
include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME} EXPORT_FILE_NAME ${PROJECT_NAME}/${PROJECT_NAME}_export.h)
target_include_directories(${PROJECT_NAME}
  PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
  ${PROJECT_SOURCE_DIR}/include
  ${Boost_INCLUDE_DIRS})
ament_target_dependencies(${PROJECT_NAME}
  "OpenCV"
  "sensor_msgs"
)
target_link_libraries(${PROJECT_NAME} ${PYTHON_LIBRARIES} ${Boost_LIBRARIES} ${OpenCV_LIBRARIES} rcpputils::rcpputils)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}_export.h
  DESTINATION include/${PROJECT_NAME})

if(NOT ANDROID)
# add a Boost Python library
find_package(PythonInterp REQUIRED)
find_package(PythonLibs "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")

# Get the numpy include directory from its python module
if(NOT PYTHON_NUMPY_INCLUDE_DIR)
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import numpy; print(numpy.get_include())"
    RESULT_VARIABLE PYTHON_NUMPY_PROCESS
    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE)

  if(PYTHON_NUMPY_PROCESS EQUAL 0)
    file(TO_CMAKE_PATH "${PYTHON_NUMPY_INCLUDE_DIR}" PYTHON_NUMPY_INCLUDE_CMAKE_PATH)
    set(PYTHON_NUMPY_INCLUDE_DIR ${PYTHON_NUMPY_INCLUDE_CMAKE_PATH} CACHE PATH "Numpy include directory")
  else()
    message(SEND_ERROR "Could not determine the NumPy include directory, verify that NumPy was installed correctly.")
  endif()
endif()

include_directories(${PYTHON_INCLUDE_PATH} ${PYTHON_NUMPY_INCLUDE_DIR})

if(PYTHON_VERSION_MAJOR VERSION_EQUAL 3)
  add_definitions(-DPYTHON3)
endif()

if(OpenCV_VERSION_MAJOR VERSION_EQUAL 4)
  add_definitions(-DOPENCV_VERSION_4)
endif()

if(OpenCV_VERSION_MAJOR VERSION_LESS 3)
  add_library(${PROJECT_NAME}_boost module.cpp module_opencv2.cpp)
else()
  add_library(${PROJECT_NAME}_boost module.cpp module_opencv3.cpp)
endif()
target_link_libraries(${PROJECT_NAME}_boost
  ${PYTHON_LIBRARIES}
  ${PROJECT_NAME}
)

set_target_properties(${PROJECT_NAME}_boost PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/boost/
                      PREFIX ""
)
if(APPLE)
  set_target_properties(${PROJECT_NAME}_boost PROPERTIES
                        SUFFIX ".so")
endif()

install(TARGETS ${PROJECT_NAME}_boost DESTINATION ${PYTHON_INSTALL_DIR}/${PROJECT_NAME}/boost/)
endif()

=== debian/changelog ===
ros-galactic-cv-bridge (3.1.3-1focal) focal; urgency=high

  * Add message to print out Boost_VERSION_STRING, and apply with CMP0093
  * Fix RHEL buildfailure with Boost 1.66.0
  * Contributors: Kenji Brameld

 -- Kenji Brameld <kenjibrameld@gmail.com>  Fri, 14 Oct 2022 15:00:00 -0000

ros-galactic-cv-bridge (3.1.2-1focal) focal; urgency=high

  * Fix windows build when Boost 1.67 or newer (#489 <https://github.com/ros-perception/vision_opencv/issues/489>)
  * Contributors: Kenji Brameld

 -- Kenji Brameld <kenjibrameld@gmail.com>  Tue, 20 Sep 2022 15:00:00 -0000

ros-galactic-cv-bridge (3.1.1-1focal) focal; urgency=high

  * Revert API breakages
  * Contributors: Kenji Brameld

 -- Kenji Brameld <kenjibrameld@gmail.com>  Fri, 16 Sep 2022 15:00:00 -0000

ros-galactic-cv-bridge (3.1.0-1focal) focal; urgency=high

  * Add apache license and bsd license, because both are used. (#482 <https://github.com/ros-perception/vision_opencv/issues/482>)
  * Fix 16U encoding type (#462 <https://github.com/ros-perception/vision_opencv/issues/462>)
  * Reorganize author tag (#468 <https://github.com/ros-perception/vision_opencv/issues/468>)
  * Update maintainers (#451 <https://github.com/ros-perception/vision_opencv/issues/451>)
  * Fix ModuleNotFoundError: No module named 'cv_bridge' error (#444 <https://github.com/ros-perception/vision_opencv/issues/444>)
  * Update README.md (#252 <https://github.com/ros-perception/vision_opencv/issues/252>)
  * Make python3-opencv from test_depend to depend tag in package.xml (#439 <https://github.com/ros-perception/vision_opencv/issues/439>)
  * Contributors: Daisuke Nishimatsu, Kenji Brameld, RachelRen05

 -- Kenji Brameld <kenjibrameld@gmail.com>  Tue, 13 Sep 2022 15:00:00 -0000

ros-galactic-cv-bridge (3.0.3-1focal) focal; urgency=high

  * Add missing dependency on rcpputils (#427 <https://github.com/ros-perception/vision_opencv/issues/427>)
  * Contributors: Shane Loretz

 -- Kenji Brameld <kenjibrameld@gmail.com>  Thu, 31 Mar 2022 15:00:00 -0000

ros-galactic-cv-bridge (3.0.2-1focal) focal; urgency=high

  * Minor cleanups to the ROS 2 branch (#418 <https://github.com/ros-perception/vision_opencv/issues/418>)
  * Find Python3 if not on Android (#423 <https://github.com/ros-perception/vision_opencv/issues/423>)
  * Forward ports from noetic (#420 <https://github.com/ros-perception/vision_opencv/issues/420>)
    * Add header arg to cv2_to_imgmsg (#326 <https://github.com/ros-perception/vision_opencv/issues/326>)
    * prevent conversion of single channel 16bit integer images to/from colour (#412 <https://github.com/ros-perception/vision_opencv/issues/412>)
  * Contributors: Chris Lalancette, Christian Rauch, Michael Carroll, Naoya Yamaguchi, Shane Loretz

 -- Kenji Brameld <kenjibrameld@gmail.com>  Wed, 26 Jan 2022 15:00:00 -0000

ros-galactic-cv-bridge (3.0.1-1focal) focal; urgency=high

  * Use Boost::python3 if Boost < 1.67 (#422 <https://github.com/ros-perception/vision_opencv/issues/422>)
  * Use Boost::pythonXY target (#421 <https://github.com/ros-perception/vision_opencv/issues/421>)
  * Contributors: Shane Loretz

 -- Kenji Brameld <kenjibrameld@gmail.com>  Mon, 24 Jan 2022 15:00:00 -0000

ros-galactic-cv-bridge (3.0.0-1focal) focal; urgency=high

  * Export Modern CMake targets and install includes to another folder(#419 <https://github.com/ros-perception/vision_opencv/issues/419>)
  * Handle padded img msg in Python (#400 <https://github.com/ros-perception/vision_opencv/issues/400>)
  * Remove boost endian (#399 <https://github.com/ros-perception/vision_opencv/issues/399>)
  * Add conversions from YUV422 YUY2 (#396 <https://github.com/ros-perception/vision_opencv/issues/396>)
  * fix endianness comparison (#397 <https://github.com/ros-perception/vision_opencv/issues/397>)
  * Export sensor_msgs dependency (#392 <https://github.com/ros-perception/vision_opencv/issues/392>)
  * Fix multiple undefined references (#370 <https://github.com/ros-perception/vision_opencv/issues/370>)
  * Updated cv_bridge.dll install location. (#356 <https://github.com/ros-perception/vision_opencv/issues/356>)
  * Contributors: Homalozoa X, Jacob Perron, Patrick Musau, Sean Yen, Shane Loretz

 -- Kenji Brameld <kenjibrameld@gmail.com>  Tue, 18 Jan 2022 15:00:00 -0000

ros-galactic-cv-bridge (2.2.1-1focal) focal; urgency=high

  * Align module.hpp with noetic (#342 <https://github.com/ros-perception/vision_opencv/issues/342>)
  * Contributors: Michael Carroll

 -- Ethan Gao <ethan.gao@linux.intel.com>  Wed, 15 Jul 2020 15:00:00 -0000

ros-galactic-cv-bridge (2.2.0-1focal) focal; urgency=high

  * Disable portable image tests (#337 <https://github.com/ros-perception/vision_opencv/issues/337>)
  * use more specific boost rosdep keys (#319 <https://github.com/ros-perception/vision_opencv/issues/319>)
  * add opencv4 into the dependency list for ROS2 (#324 <https://github.com/ros-perception/vision_opencv/issues/324>)
  * Corrected the typo of Boost_INCLUDE_DIRS (#315 <https://github.com/ros-perception/vision_opencv/issues/315>)
  * use target include directories (#313 <https://github.com/ros-perception/vision_opencv/issues/313>)
  * Contributors: Karsten Knese, Lewis Liu, Michael Carroll, Mikael Arguedas, Sean Yen

 -- Ethan Gao <ethan.gao@linux.intel.com>  Tue, 26 May 2020 15:00:00 -0000

ros-galactic-cv-bridge (2.1.3-1focal) focal; urgency=high

  * populate array.array directly instead of converting to and from a string (#305 <https://github.com/ros-perception/vision_opencv/issues/305>)
  * include Boost to fix Windows build (#290 <https://github.com/ros-perception/vision_opencv/issues/290>)
  * Export interfaces for Win32 Shared Lib (#301 <https://github.com/ros-perception/vision_opencv/issues/301>)
  * Contributors: Dirk Thomas, Jonathan Noyola, Sean Yen

 -- Ethan Gao <ethan.gao@linux.intel.com>  Tue, 22 Oct 2019 15:00:00 -0000

ros-galactic-cv-bridge (2.1.2-1focal) focal; urgency=high



=== debian/control ===
Source: ros-galactic-cv-bridge
Section: misc
Priority: optional
Maintainer: Kenji Brameld <kenjibrameld@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-dev, libboost-python-dev, libopencv-dev, python3-numpy, python3-opencv, ros-galactic-ament-cmake-gtest <!nocheck>, ros-galactic-ament-cmake-pytest <!nocheck>, ros-galactic-ament-cmake-ros, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-python-cmake-module, ros-galactic-rcpputils, ros-galactic-sensor-msgs, ros-galactic-ros-workspace
Homepage: http://www.ros.org/wiki/cv_bridge
Standards-Version: 3.9.2

Package: ros-galactic-cv-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-python1.71.0, libopencv-dev, python3-numpy, python3-opencv, ros-galactic-ament-index-python, ros-galactic-rcpputils, ros-galactic-sensor-msgs, ros-galactic-ros-workspace
Description: This contains CvBridge, which converts between ROS2 Image messages and OpenCV images.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-cv-bridge//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
